
Foreman - Bug #13982

API description for creating hosts incorrectly lists "interfaces_attributes"'s "primary" as optional

03/01/2016 10:57 AM - Pieter Hollants

Status: Duplicate   

Priority: High   

Assignee:    

Category: API   

Target version:    

Difficulty: easy Fixed in Releases:  

Triaged:  Found in Releases: 1.9.3

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

http://theforeman.org/api/1.10/apidoc/v2/hosts/create.html says:

host[interfaces_attributes][primary]

optional , nil allowed

 The "optional" flag seems to be wrong:

$ curl -s -H "Content-Type: application/json" k -u admin:secret -d '{"host":{"hostgroup_id": "1", "name": "test",

"environment_id":"1",

"interfaces_attributes":{"0":{"ip":"192.168.100.5","mac":"00:11:22:33:44:55","type":"interface","identifier":"eth0"}}}}' 

http://foreman.test.foo/api/hosts {

"error": {"id":null,"errors":{"interfaces.mac":["can't be blank"]},"full_messages":["Mac can't be blank"]}

}

$ curl -s -H "Content-Type: application/json" k -u admin:secret -d '{"host":{"hostgroup_id": "1", "name": "test",

"environment_id":"1", "interfaces_attributes":{"0":{"ip":"192.168.100.5","mac":"00:11:22:33:44:55","primary":"true"}}}}' 

http://foreman.test.foo/api/hosts {"ip":"192.168.100.5", ... ,"all_puppetclasses":[]}

Related issues:

Is duplicate of Foreman - Bug #14239: Creating a host via API fails with cryp... Closed 03/16/2016

History

#1 - 03/18/2016 05:17 AM - Dominic Cleal

- Is duplicate of Bug #14239: Creating a host via API fails with cryptic error when no primary interface is set explicitly added

#2 - 03/18/2016 05:18 AM - Dominic Cleal

- Status changed from New to Duplicate

I think #14239 has fixed this in a different way, by automatically setting a primary interface if none is specified.  The attribute remains optional. 

Thanks for the report.
